Summary: Throttleable lightweight httpd server
Name: thttpd
Version: 2.20b
Release: 4
Group: System Environment/Daemons
URL: http://www.acme.com/software/thttpd
Source0: http://www.acme.com/software/thttpd/thttpd-%{version}.tar.gz
Source1: thttpd.init
Patch0: webdir.patch
Patch1: thttpd-time.patch
Copyright: distributable (BSD)
BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{_prefix}
PreReq: /sbin/chkconfig , /sbin/service
Conflicts: apache

%description
Thttpd is a very compact no-frills httpd serving daemon that can handle
very high loads.  While lacking many of the advanced features of
Apachee, thttpd operates without forking and is extremely efficient in
memory use.  Basic support for cgi scripts, authentication, and ssi is
provided for.  Advanced features include the ability to throttle traffic.

%prep

%setup -q
%patch0 -p1
%patch1 -p1

%build
%configure
CFLAGS=$RPM_OPT_FLAGS make WEBDIR=/var/thttpd \
    BINDIR=%{_prefix}/sbin \
    prefix=%{_prefix} \
    CGIBINDIR=/var/thttpd/cgi-bin \
    WEBGROUP=thttpd

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/var/thttpd/{cgi-bin,logs}
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man{8,1}
mkdir -p $RPM_BUILD_ROOT/usr/sbin

install -m555 thttpd  $RPM_BUILD_ROOT/usr/sbin
install -m755 $RPM_SOURCE_DIR/thttpd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/thttpd
install -m644 contrib/redhat-rpm/thttpd.conf $RPM_BUILD_ROOT/etc/
install -m755 extras/makeweb $RPM_BUILD_ROOT/usr/sbin
install -m755 extras/htpasswd $RPM_BUILD_ROOT/usr/sbin
install -m755 extras/syslogtocern $RPM_BUILD_ROOT/usr/sbin
install -m755 cgi-src/redirect $RPM_BUILD_ROOT/var/thttpd/cgi-bin
install -m755 cgi-src/ssi $RPM_BUILD_ROOT/var/thttpd/cgi-bin
install -m755 cgi-src/phf $RPM_BUILD_ROOT/var/thttpd/cgi-bin

install -m644 `find . -name "*.1"` $RPM_BUILD_ROOT%{_mandir}/man1
install -m644 `find . -name "*.8"` $RPM_BUILD_ROOT%{_mandir}/man8

rm -f $RPM_BUILD_ROOT%{_mandir}/man1/htpasswd.1*

%pre
/usr/sbin/useradd -d /var/thttpd -u 72 thttpd 

%post
/sbin/chkconfig --add thttpd

%preun
if [ "$1" = "0" ]; then
	/sbin/service thttpd stop > /dev/null 2>&1
	/sbin/chkconfig --del thttpd
fi

%postun
if [ "$1" -ge "1" ]; then
	/sbin/service thttpd condrestart > /dev/null 2>&1
else
	/usr/sbin/userdel thttpd
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc FILES INSTALL README TODO
%config /etc/rc.d/init.d/thttpd
%attr(0555,bin,bin)/usr/sbin/thttpd
%attr(-,root,thttpd)/usr/sbin/makeweb
/usr/sbin/htpasswd
/usr/sbin/syslogtocern
%attr(-,thttpd,thttpd)/var/thttpd/cgi-bin
%{_mandir}/*/*

%changelog
* Sun Feb 25 2001 Tim Powers <timp@redhat.com>
- made to conflict with apache so that RPM exits cleanly if apache is
  installed already. htpasswd and it's manpage are both provided by
  apache and this package (29373)

* Thu Feb 15 2001 Tim Powers <timp@redhat.com>
- patched to include time.h instead of just sys/time.h

* Tue Jan 23 2001 Tim Powers <timp@redhat.com>
- updated initscript

* Fri Jan 12 2001 Tim Powers <timp@redhat.com>
- updated to 2.20b

* Fri Jul 28 2000 Than Ngo <than@redhat.de>
- add missing restart function in startup script
- use %%{_tmppath}

* Fri Jul 28 2000 Tim Powers <timp@redhat.com>
- fixed initscript so condrestart doesn't return 1 when the test fails

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Wed Jul 19 2000 Tim Powers <timp@redhat.com>
- built against glibc-2.1.91-15

* Mon Jul 17 2000 Tim Powers <timp@redhat.com>
- inoits back to rc.d/init.d. Using /sbi/service to start/stop inits

* Mon Jul 10 2000 Tim Powers <timp@redhat.com>
- rebuilt

* Thu Jul 06 2000 Tim Powers <timp@redhat.com>
- fixed PreReq to PreReq /etc/init.d

* Tue Jun 27 2000 Tim Powers <timp@redhat.com>
- fixed init script so it has condrestart, reworked the whole thing a bit
- fixed init.d location so that it is FHSized
- added PreReq

* Fri Jun 2 2000 Tim Powers <timp@redhat.com>
- fixed so that we no longer create a home dir and place stuff under /home,
  now in /var/thttpd

* Mon May 22 2000 Tim Powers <timp@redhat.com>
- updated to 2.16
- use %configure
- man pages in /usr/share/man

* Thu Dec 16 1999 Tim Powers <timp@redhat.com>
- based on spec file in Contrib|Net
- major spec file cleanups, reorg, too many to mention
- initial build for Powertools
- made init script chkconfig compliant
